// Copyright (c) 2024 Codemongous LLC. All Rights Reserved.

#pragma once
#include "ISCW_UK2Node_Switch.h"

#include <memory>
#include <string>

using std::shared_ptr;
using std::wstring;

namespace Sourcify
{
	class ISCW_UEnum;

	class ISCW_UK2Node_SwitchEnum : public virtual ISCW_UK2Node_Switch
	{
	public:
		virtual ~ISCW_UK2Node_SwitchEnum() = default;

		virtual shared_ptr<ISCW_UEnum> GetEnum() const = 0;

		virtual void ReloadEnum(shared_ptr<ISCW_UEnum> InEnum) = 0;
		
		virtual std::shared_ptr<ISCW_UK2Node_SwitchEnum> ToUK2Node_SwitchEnumPtr() = 0;
		virtual std::shared_ptr<const ISCW_UK2Node_SwitchEnum> ToUK2Node_SwitchEnumPtr() const = 0;
	};

	using ISCW_UK2Node_SwitchEnumConstPtr = std::shared_ptr<const ISCW_UK2Node_SwitchEnum>;
	using ISCW_UK2Node_SwitchEnumPtr = std::shared_ptr<ISCW_UK2Node_SwitchEnum>;
} // namespace Sourcify